SystemOrganization addCategory: #ConfigurationOfZenna!

Object subclass: #ConfigurationOfZenna
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfZenna'!

!ConfigurationOfZenna class methodsFor: 'development support' stamp: 'emm 9/30/2012 12:12'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfZenna class methodsFor: 'private' stamp: 'emm 9/30/2012 12:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfZenna class methodsFor: 'private' stamp: 'emm 9/30/2012 12:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfZenna class methodsFor: 'private' stamp: 'emm 9/30/2012 12:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfZenna class methodsFor: 'metacello tool support' stamp: 'emm 9/30/2012 12:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfZenna class methodsFor: 'loading' stamp: 'emm 9/30/2012 12:12'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfZenna class methodsFor: 'loading' stamp: 'emm 9/30/2012 12:12'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfZenna class methodsFor: 'loading' stamp: 'emm 9/30/2012 12:12'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfZenna class methodsFor: 'accessing' stamp: 'emm 9/30/2012 12:12'!
project

	^self new project! !

!ConfigurationOfZenna class methodsFor: 'development support' stamp: 'emm 9/30/2012 12:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfZenna methodsFor: 'baselines' stamp: 'emm 10/2/2012 21:27'!
allPackageNames100
	^#(
	'Animation3D'
	'Appearance3D'
	'Core2D'
	'Dominos'
	'Extensions'
	'FileIO'
	'FormatDirectX'
	'FormatM3D'
	'FormatMaxScript'
	'FormatPOVRay'
	'FormatSVG'
	'FormatVRML'
	'FormatThreeJS'
	'Lindenmayer'
	'Modelling2D'
	'Operators3D'
	'OperatorsCSG'
	'Primitives3D'
	'SceneBuilding2D'
	'SceneBuilding3D'
	'ShapeGallery'
	'Shapes3D'
	'Structures3D'
	'TaggedData'
	'Wrappers3D') collect:[ :e |  'Zenna-' , e]! !

!ConfigurationOfZenna methodsFor: 'baselines' stamp: 'emm 9/30/2012 19:33'!
baseline100: spec 
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [| all |
			spec blessing: #baseline.
			spec repository: 'http://ss3.gemstone.com/ss/Zenna'. 
			all := self allPackageNames100.
			all
				do: [:each | spec package: each].
			spec package: 'Zenna-Tests'.
			spec group: 'default' with: all;
				 group: 'Tests' with: #('Zenna-Tests' ).
			spec postLoadDoIt: #postloadForBaseline100]! !

!ConfigurationOfZenna methodsFor: 'accessing' stamp: 'emm 9/30/2012 12:12'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfZenna methodsFor: 'baselines' stamp: 'emm 10/2/2012 21:26'!
postloadForBaseline100
	#(#Point3D #CurvedArrow #Math3DConstants #TaggedDataReader) do: [ :each |
		(Smalltalk at: each) initializeAfterLoad ].
	GraphicsFileAccessor workingDirectoryName: '/tmp'.
	Smalltalk organization sortCategories.
	! !

!ConfigurationOfZenna methodsFor: 'accessing' stamp: 'emm 9/30/2012 12:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfZenna methodsFor: 'versions' stamp: 'emm 9/30/2012 19:23'!
version100: spec 
        <version: '1.0' imports: #('1.0-baseline') >
        
        spec for: #common do: [
                spec blessing: #development ].! !
